Index: squid3/src/ICAPXaction.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/Attic/ICAPXaction.cc,v
retrieving revision 1.1.2.12
retrieving revision 1.1.2.13
diff -u -r1.1.2.12 -r1.1.2.13
--- squid3/src/ICAPXaction.cc	25 Aug 2005 22:09:00 -0000	1.1.2.12
+++ squid3/src/ICAPXaction.cc	26 Aug 2005 20:28:41 -0000	1.1.2.13
@@ -87,548 +94,613 @@
 	callEnd(#method);
 
 
-ICAPXaction::State::State() {
-	memset(this, sizeof(*this), 0);
+ICAPXaction::State::State()
+{
+    memset(this, sizeof(*this), 0);
 }
 
 ICAPXaction::ICAPXaction(): self(NULL), virgin(NULL), adapted(NULL),
-	icapReply(NULL), service(NULL), connection(-1), notify(notifyUnknown) {
-}
+        icapReply(NULL), service(NULL), connection(-1), notify(notifyUnknown)
+{}
+
+ICAPXaction::~ICAPXaction()
+{
+    notify = notifyNone;
+    doStop();
 
-ICAPXaction::~ICAPXaction() {
-	notify = notifyNone;
-	doStop();
-	if (icapReply)
-		httpReplyDestroy(icapReply);
+    if (icapReply)
+        httpReplyDestroy(icapReply);
 }
 
-void ICAPXaction::init(MsgPipe *aVirgin, MsgPipe *anAdapted, Pointer &aSelf) {
-	assert(!self.getRaw() && !virgin && !adapted);
-	assert(aSelf.getRaw() && aVirgin && anAdapted);
+void ICAPXaction::init(MsgPipe *aVirgin, MsgPipe *anAdapted, Pointer &aSelf)
+{
+    assert(!self.getRaw() && !virgin && !adapted);
+    assert(aSelf.getRaw() && aVirgin && anAdapted);
 
-	self = aSelf;
-	virgin = aVirgin;
-	adapted = anAdapted;
+    self = aSelf;
+    virgin = aVirgin;
+    adapted = anAdapted;
 
-	// receiving end
-	virgin->sink = this; // should be 'self' and refcounted
-	// virgin pipe data is initiated by the source
+    // receiving end
+    virgin->sink = this; // should be 'self' and refcounted
+    // virgin pipe data is initiated by the source
 
-	// sending end
-	adapted->source = this; // should be 'self' and refcounted
-	adapted->data = new MsgPipeData;
-	adapted->data->header = httpReplyCreate(); // who is deleting? refcount?
-	adapted->data->body = new MemBuf; // XXX: make body a non-pointer?
-	memBufInit(adapted->data->body, ICAPMsgPipeBufSizeMin, ICAPMsgPipeBufSizeMax);
-	// headers are initialized when we parse them
+    // sending end
+    adapted->source = this; // should be 'self' and refcounted
+    adapted->data = new MsgPipeData;
+    adapted->data->header = httpReplyCreate(); // who is deleting? refcount?
+    adapted->data->body = new MemBuf; // XXX: make body a non-pointer?
+    memBufInit(adapted->data->body, ICAPMsgPipeBufSizeMin, ICAPMsgPipeBufSizeMax);
+    // headers are initialized when we parse them
 
-	// writing end
-	// nothing to do because we are using temporary write buffers
+    // writing end
+    // nothing to do because we are using temporary write buffers
 
-	// reading end
-	memBufDefInit(&readBuf);
+    // reading end
+    memBufDefInit(&readBuf);
 
-	// encoding
-	memBufDefInit(&requestBuf);
+    // encoding
+    memBufDefInit(&requestBuf);
 
-	// parsing
-	icapReply = httpReplyCreate();
-	icapReply->protoPrefix = "ICAP/"; // TODO: make an IcapReply class?
+    // parsing
+    icapReply = httpReplyCreate();
+    icapReply->protoPrefix = "ICAP/"; // TODO: make an IcapReply class?
 
-	// XXX: make sure stop() cleans all buffers
+    // XXX: make sure stop() cleans all buffers
 }
 
 // HTTP side starts sending virgin data
-void ICAPXaction::noteSourceStart(MsgPipe *p) {
-	ICAPXaction_Enter(noteSourceStart);
-
-	pickService();
-	openConnection();
-	// put nothing here as openConnection calls commConnectStart
-	// and that may call us back without waiting for the next select loop
-	
-	// XXX: but this has to be here to catch other errors. Thus, if 
-	// commConnectStart fails (see the comment above), we may get here
-	// _after_ the object got destroyed. Somebody please fix commConnectStart!
-	ICAPXaction_Exit(noteSourceStart);
+void ICAPXaction::noteSourceStart(MsgPipe *p)
+{
+    ICAPXaction_Enter(noteSourceStart);
+
+    pickService();
+    openConnection();
+    // put nothing here as openConnection calls commConnectStart
+    // and that may call us back without waiting for the next select loop
+
+    // XXX: but this has to be here to catch other errors. Thus, if
+    // commConnectStart fails (see the comment above), we may get here
+    // _after_ the object got destroyed. Somebody please fix commConnectStart!
+    ICAPXaction_Exit(noteSourceStart);
 }
 
 // TODO: obey service-specific, OPTIONS-reported connection limit
-void ICAPXaction::openConnection() {
-	// TODO: check whether NULL domain is appropriate here
-	connection = pconnPop(service->host, service->port, NULL);
-
-	if (connection < 0) {
-		connection = comm_open(SOCK_STREAM, 0, getOutgoingAddr(NULL), 0,
-			COMM_NONBLOCKING, service->uri);
-		if (connection < 0)
-			throw TexcHere("cannot connect to ICAP service " /* + uri */);
-	}
-
-	commSetTimeout(connection, Config.Timeout.connect,
-		&ICAPXaction_noteCommTimeout, this);
-	state.closer = &ICAPXaction_noteCommClose;
-	comm_add_close_handler(connection, state.closer, this);
-	commConnectStart(connection, service->host, service->port,
-		&ICAPXaction_noteCommConnected, this);
-}
-
-void ICAPXaction::closeConnection() {
-	if (connection >= 0) {
-		commSetTimeout(connection, -1, NULL, NULL);
-		if (state.closer)
-			comm_remove_close_handler(connection, state.closer, this);
-		stopReading();
-		comm_close(connection);
-		connection = -1;
-	}
+void ICAPXaction::openConnection()
+{
+    // TODO: check whether NULL domain is appropriate here
+    connection = pconnPop(service->host, service->port, NULL);
+
+    if (connection < 0) {
+        connection = comm_open(SOCK_STREAM, 0, getOutgoingAddr(NULL), 0,
+                               COMM_NONBLOCKING, service->uri);
+
+        if (connection < 0)
+            throw TexcHere("cannot connect to ICAP service " /* + uri */);
+    }
+
+    commSetTimeout(connection, Config.Timeout.connect,
+                   &ICAPXaction_noteCommTimeout, this);
+    state.closer = &ICAPXaction_noteCommClose;
+    comm_add_close_handler(connection, state.closer, this);
+    commConnectStart(connection, service->host, service->port,
+                     &ICAPXaction_noteCommConnected, this);
+}
+
+void ICAPXaction::closeConnection()
+{
+    if (connection >= 0) {
+        commSetTimeout(connection, -1, NULL, NULL);
+
+        if (state.closer)
+            comm_remove_close_handler(connection, state.closer, this);
+
+        stopReading();
+
+        comm_close(connection);
+
+        connection = -1;
+    }
 }
 
 // connection with the ICAP service established
-void ICAPXaction::noteCommConnected(comm_err_t status) {
-	ICAPXaction_Enter(noteCommConnected);
+void ICAPXaction::noteCommConnected(comm_err_t status)
+{
+    ICAPXaction_Enter(noteCommConnected);
 
-	Must(status == COMM_OK);
+    Must(status == COMM_OK);
 
-	startReading(); // wait for early errors from the ICAP server
+    startReading(); // wait for early errors from the ICAP server
 
-	makeRequestHeaders();
-	// write headers only; comm module will free the requestBuf
-	state.isWriting = &ICAPXaction_noteCommWroteHeaders;
-	comm_old_write_mbuf(connection, requestBuf, state.isWriting, this);
+    makeRequestHeaders();
+    // write headers only; comm module will free the requestBuf
+    state.isWriting = &ICAPXaction_noteCommWroteHeaders;
+    comm_old_write_mbuf(connection, requestBuf, state.isWriting, this);
 
-	ICAPXaction_Exit(noteCommConnected);
+    ICAPXaction_Exit(noteCommConnected);
 }
 
-void ICAPXaction::noteCommWroteHeaders(comm_err_t status) {
-	ICAPXaction_Enter(noteCommWroteHeaders);
+void ICAPXaction::noteCommWroteHeaders(comm_err_t status)
+{
+    ICAPXaction_Enter(noteCommWroteHeaders);
 
-	Must(state.isWriting);
-	state.isWriting = NULL;
+    Must(state.isWriting);
+    state.isWriting = NULL;
 
-	Must(status == COMM_OK);
-	writeMoreBody();
+    Must(status == COMM_OK);
+    writeMoreBody();
 
-	ICAPXaction_Exit(noteCommWroteHeaders);
+    ICAPXaction_Exit(noteCommWroteHeaders);
 }
 
-void ICAPXaction::writeMoreBody() {
-	if (state.isWriting || state.doneWriting)
-		return;
+void ICAPXaction::writeMoreBody()
+{
+    if (state.isWriting || state.doneWriting)
+        return;
+
+    MsgPipeData::Body *body = virgin->data->body;
+
+    MemBuf writeBuf; // TODO: suggest a min size based on body and lastChunk
+
+    memBufDefInit(&writeBuf);
+
+    if (body->hasContent()) {
+        debugs(93, 7, "ICAPXaction will write " << body->contentSize() <<
+               "-byte chunk");
+        moveRequestChunk(&writeBuf);
+        Must(!body->hasContent()); // we should have moved all of it above
 
-	MsgPipeData::Body *body = virgin->data->body;
-	MemBuf writeBuf; // TODO: suggest a min size based on body and lastChunk
-	memBufDefInit(&writeBuf);
+        if (!state.doneReceiving)
+            virgin->sendSinkNeed();
+    }
 
-	if (body->hasContent()) {
-		debugs(93, 7, "ICAPXaction will write " << body->contentSize() <<
-			"-byte chunk");
-		moveRequestChunk(&writeBuf);
-		Must(!body->hasContent()); // we should have moved all of it above
-		if (!state.doneReceiving)
-			virgin->sendSinkNeed();
-	}
-	
-	if (state.doneReceiving && !state.doneWriting) {
-		debugs(93, 7, "ICAPXaction will write last-chunk");
-		moveRequestChunk(&writeBuf);  // will add zero-size chunk
-		state.doneWriting = true;
-	}
+    if (state.doneReceiving && !state.doneWriting) {
+        debugs(93, 7, "ICAPXaction will write last-chunk");
+        moveRequestChunk(&writeBuf);  // will add zero-size chunk
+        state.doneWriting = true;
+    }
 
-	debugs(93, 7, "ICAPXaction will write " << writeBuf.contentSize() << " bytes");
-	if (writeBuf.hasContent()) {
-		// comm will free the chunk
-		state.isWriting = &ICAPXaction_noteCommWroteBody;
-		comm_old_write_mbuf(connection, writeBuf, state.isWriting, this);
-	}
+    debugs(93, 7, "ICAPXaction will write " << writeBuf.contentSize() << " bytes");
+
+    if (writeBuf.hasContent()) {
+        // comm will free the chunk
+        state.isWriting = &ICAPXaction_noteCommWroteBody;
+        comm_old_write_mbuf(connection, writeBuf, state.isWriting, this);
+    }
 }
 
-void ICAPXaction::moveRequestChunk(MemBuf *buf) {
-	MsgPipeData::Body *body = virgin->data->body;
-	const mb_size_t chunkSize = body->contentSize(); // may be zero
-	memBufPrintf(buf, "%x\r\n", chunkSize);
-	if (chunkSize > 0) {
-		buf->append(body->content(), chunkSize);
-		body->consume(chunkSize);
-	}
-	buf->append(crlf, 2); // chunk-terminating CRLF
+void ICAPXaction::moveRequestChunk(MemBuf *buf)
+{
+    MsgPipeData::Body *body = virgin->data->body;
+    const mb_size_t chunkSize = body->contentSize(); // may be zero
+    memBufPrintf(buf, "%x\r\n", chunkSize);
+
+    if (chunkSize > 0) {
+        buf->append(body->content(), chunkSize);
+        body->consume(chunkSize);
+    }
+
+    buf->append(crlf, 2); // chunk-terminating CRLF
 }
 
-void ICAPXaction::noteCommWroteBody(comm_err_t status, size_t sz) {
-	ICAPXaction_Enter(noteCommWroteBody);
+void ICAPXaction::noteCommWroteBody(comm_err_t status, size_t sz)
+{
+    ICAPXaction_Enter(noteCommWroteBody);
 
-	state.isWriting = NULL;
-	Must(status == COMM_OK);
-	writeMoreBody();
+    state.isWriting = NULL;
+    Must(status == COMM_OK);
+    writeMoreBody();
 
-	ICAPXaction_Exit(noteCommWroteBody);
+    ICAPXaction_Exit(noteCommWroteBody);
 }
 
 // communication timeout with the ICAP service
-void ICAPXaction::noteCommTimeout() {
-	ICAPXaction_Enter(noteCommTimeout);
+void ICAPXaction::noteCommTimeout()
+{
+    ICAPXaction_Enter(noteCommTimeout);
 
-	mustStop(notifyHttp);
+    mustStop(notifyHttp);
 
-	ICAPXaction_Exit(noteCommTimeout);
+    ICAPXaction_Exit(noteCommTimeout);
 }
 
 // unexpected connection close while talking to the ICAP service
-void ICAPXaction::noteCommClose() {
-	state.closer = NULL;
-	ICAPXaction_Enter(noteCommClose);
+void ICAPXaction::noteCommClose()
+{
+    state.closer = NULL;
+    ICAPXaction_Enter(noteCommClose);
 
-	mustStop(notifyHttp);
+    mustStop(notifyHttp);
 
-	ICAPXaction_Exit(noteCommClose);
+    ICAPXaction_Exit(noteCommClose);
 }
 
-bool ICAPXaction::done() const {
-	if (notify != notifyUnknown) // mustStop() has been called
-		return true;
+bool ICAPXaction::done() const
+{
+    if (notify != notifyUnknown) // mustStop() has been called
+        return true;
 
-	return state.doneReceiving && state.doneSending &&
-		state.doneReading && state.doneWriting;
+    return state.doneReceiving && state.doneSending &&
+           state.doneReading && state.doneWriting;
 }
 
-void ICAPXaction::startReading() {
-	Must(connection >= 0 && !state.isReading &&
-		adapted && adapted->data && adapted->data->body);
+void ICAPXaction::startReading()
+{
+    Must(connection >= 0 && !state.isReading &&
+         adapted && adapted->data && adapted->data->body);
 
-	readMore();
+    readMore();
 }
 
-void ICAPXaction::readMore() {
-	if (state.isReading || state.doneReading)
-		return;
+void ICAPXaction::readMore()
+{
+    if (state.isReading || state.doneReading)
+        return;
 
-	// do not fill readBuf if we have no space to store the result
-	if (!adapted->data->body->hasPotentialSpace())
-		return;
-	
-	// we use the same buffer for headers and body and then consume headers
-	if (readBuf.hasSpace()) {
-		state.isReading = &ICAPXaction_noteCommRead;
-		comm_read(connection, readBuf.space(), readBuf.spaceSize(),
-			state.isReading, this);
-	}
+    // do not fill readBuf if we have no space to store the result
+    if (!adapted->data->body->hasPotentialSpace())
+        return;
+
+    // we use the same buffer for headers and body and then consume headers
+    if (readBuf.hasSpace()) {
+        state.isReading = &ICAPXaction_noteCommRead;
+        comm_read(connection, readBuf.space(), readBuf.spaceSize(),
+                  state.isReading, this);
+    }
 }
 
 // comm module read a portion of the ICAP response for us
-void ICAPXaction::noteCommRead(comm_err_t status, size_t sz) {
-	ICAPXaction_Enter(noteCommRead);
+void ICAPXaction::noteCommRead(comm_err_t status, size_t sz)
+{
+    ICAPXaction_Enter(noteCommRead);
+
+    Must(state.isReading);
+    state.isReading = NULL;
 
-	Must(state.isReading);
-	state.isReading = NULL;
+    Must(!state.doneParsing());
+    Must(status == COMM_OK);
 
-	Must(!state.doneParsing());
-	Must(status == COMM_OK);
+    debugs(93, 5, "read " << sz << " bytes");
 
-	debugs(93, 5, "read " << sz << " bytes");
+    if (sz == 0)
+        stopReading();
+    else
+        if (sz > 0)
+            readBuf.appended(sz);
 
-	if (sz == 0)
-		stopReading();
-	else
-	if (sz > 0)
-		readBuf.appended(sz);
+    parseMore();
 
-	parseMore();
-	readMore();
+    readMore();
 
-	ICAPXaction_Exit(noteCommRead);
+    ICAPXaction_Exit(noteCommRead);
 }
 
-void ICAPXaction::stopReading() {
-	if (state.isReading) {
-		comm_read_cancel(connection, state.isReading, this);
-		state.isReading = NULL;
-	}
-	state.doneReading = true;
+void ICAPXaction::stopReading()
+{
+    if (state.isReading) {
+        comm_read_cancel(connection, state.isReading, this);
+        state.isReading = NULL;
+    }
+
+    state.doneReading = true;
 }
 
-void ICAPXaction::parseMore() {
-	debugs(93, 5, "have " << readBuf.contentSize() << " bytes to parse" <<
-		"; state: " << state.parsing);
+void ICAPXaction::parseMore()
+{
+    debugs(93, 5, "have " << readBuf.contentSize() << " bytes to parse" <<
+           "; state: " << state.parsing);
 
-	if (state.parsingHeaders())
-		parseHeaders();
+    if (state.parsingHeaders())
+        parseHeaders();
 
-	if (state.parsing == State::psBody)
-		parseBody();
+    if (state.parsing == State::psBody)
+        parseBody();
 }
 
-void ICAPXaction::parseHeaders() {
-	Must(state.parsingHeaders());
+void ICAPXaction::parseHeaders()
+{
+    Must(state.parsingHeaders());
 
-	if (state.parsing == State::psIcapHeader)
-		parseHeader(icapReply);
+    if (state.parsing == State::psIcapHeader)
+        parseHeader(icapReply);
 
-	if (state.parsing == State::psHttpHeader) {
-		if (gotEncapsulated("res-hdr"))
-			parseHeader(adapted->data->header);
-		else
-			state.parsing = State::psBody;
-	}
+    if (state.parsing == State::psHttpHeader) {
+        if (gotEncapsulated("res-hdr"))
+            parseHeader(adapted->data->header);
+        else
+            state.parsing = State::psBody;
+    }
 
-	if (state.parsingHeaders()) // need more data
-		Must(!state.doneReading);
-	else
-		adapted->sendSourceStart();
+    if (state.parsingHeaders()) // need more data
+        Must(!state.doneReading);
+    else
+        adapted->sendSourceStart();
 }
 
-void ICAPXaction::parseHeader(HttpReply *header) {
-	debugs(93, 5, "have " << readBuf.contentSize() << " hdr bytes to parse" <<
-		"; state: " << state.parsing);
+void ICAPXaction::parseHeader(HttpReply *header)
+{
+    debugs(93, 5, "have " << readBuf.contentSize() << " hdr bytes to parse" <<
+           "; state: " << state.parsing);
+
+    http_status error = HTTP_STATUS_NONE;
+    const bool parsed = header->parse(&readBuf, state.doneReading, &error);
+    Must(!error);
 
-	http_status error = HTTP_STATUS_NONE;
-	const bool parsed = header->parse(&readBuf, state.doneReading, &error);
-	Must(!error);
-	if (!parsed) {
-		httpReplyReset(header);
-		return;
-	}
+    if (!parsed) {
+        httpReplyReset(header);
+        return;
+    }
 
-	readBuf.consume(header->hdr_sz);
-	state.parsing = (State::Parsing)(state.parsing + 1);
+    readBuf.consume(header->hdr_sz);
+    state.parsing = (State::Parsing)(state.parsing + 1);
 }
 
-void ICAPXaction::parseBody() {
-	Must(state.parsing == State::psBody);
+void ICAPXaction::parseBody()
+{
+    Must(state.parsing == State::psBody);
 
-	debugs(93, 5, "have " << readBuf.contentSize() << " body bytes to parse");
+    debugs(93, 5, "have " << readBuf.contentSize() << " body bytes to parse");
 
-	if (gotEncapsulated("res-body")) {
-		if (!parsePresentBody())
-			return;
-	} else {
-		debugs(93, 5, "not expecting a body");
-	}
-
-	stopReading();
-	state.parsing = State::psDone;
-	state.doneSending = true;
-	adapted->sendSourceFinish();
-	delete bodyParser;
-	bodyParser = 0;
-}
-
-bool ICAPXaction::parsePresentBody() {
-	if (!bodyParser)
-		bodyParser = new ChunkedCodingParser;
-
-	// the parser will throw on errors
-	const bool parsed = bodyParser->parse(&readBuf, adapted->data->body);
-	adapted->sendSourceProgress();
-
-	debugs(93, 5, "have " << readBuf.contentSize() << " body bytes after " <<
-		   "parse; parsed all: " << parsed);
-
-	if (!parsed) { // needs more data
-		Must(!state.doneReading); // will get more
-		Must(readBuf.hasSpace()); // have place for more
-		return false;
-	}
+    if (gotEncapsulated("res-body")) {
+        if (!parsePresentBody())
+            return;
+    } else {
+        debugs(93, 5, "not expecting a body");
+    }
 
-	return true;
+    stopReading();
+    state.parsing = State::psDone;
+    state.doneSending = true;
+    adapted->sendSourceFinish();
+    delete bodyParser;
+    bodyParser = 0;
+}
+
+bool ICAPXaction::parsePresentBody()
+{
+    if (!bodyParser)
+        bodyParser = new ChunkedCodingParser;
+
+    // the parser will throw on errors
+    const bool parsed = bodyParser->parse(&readBuf, adapted->data->body);
+
+    adapted->sendSourceProgress();
+
+    debugs(93, 5, "have " << readBuf.contentSize() << " body bytes after " <<
+           "parse; parsed all: " << parsed);
+
+    if (!parsed) { // needs more data
+        Must(!state.doneReading); // will get more
+        Must(readBuf.hasSpace()); // have place for more
+        return false;
+    }
+
+    return true;
 }
 
 // HTTP side added virgin body data
-void ICAPXaction::noteSourceProgress(MsgPipe *p) {
-	ICAPXaction_Enter(noteSourceProgress);
+void ICAPXaction::noteSourceProgress(MsgPipe *p)
+{
+    ICAPXaction_Enter(noteSourceProgress);
 
-	Must(!state.doneReceiving);
-	writeMoreBody();
+    Must(!state.doneReceiving);
+    writeMoreBody();
 
-	ICAPXaction_Exit(noteSourceProgress);
+    ICAPXaction_Exit(noteSourceProgress);
 }
 
 // HTTP side sent us all virgin info
-void ICAPXaction::noteSourceFinish(MsgPipe *p) {
-	ICAPXaction_Enter(noteSourceFinish);
-
-	Must(!state.doneReceiving);
-	state.doneReceiving = true;
-	writeMoreBody(); // in case we were waiting to send the last-chunk
+void ICAPXaction::noteSourceFinish(MsgPipe *p)
+{
+    ICAPXaction_Enter(noteSourceFinish);
+
+    Must(!state.doneReceiving);
+    state.doneReceiving = true;
+    writeMoreBody(); // in case we were waiting to send the last-chunk
 
-	ICAPXaction_Exit(noteSourceFinish);
+    ICAPXaction_Exit(noteSourceFinish);
 }
 
 // HTTP side is aborting
-void ICAPXaction::noteSourceAbort(MsgPipe *p) {
-	ICAPXaction_Enter(noteSourceAbort);
+void ICAPXaction::noteSourceAbort(MsgPipe *p)
+{
+    ICAPXaction_Enter(noteSourceAbort);
 
-	Must(!state.doneReceiving);
-	state.doneReceiving = true;
+    Must(!state.doneReceiving);
+    state.doneReceiving = true;
 
-	ICAPXaction_Exit(noteSourceAbort);
+    ICAPXaction_Exit(noteSourceAbort);
 }
 
 // HTTP side wants more adapted data and possibly freed some buffer space
-void ICAPXaction::noteSinkNeed(MsgPipe *p) {
-	ICAPXaction_Enter(noteSinkNeed);
+void ICAPXaction::noteSinkNeed(MsgPipe *p)
+{
+    ICAPXaction_Enter(noteSinkNeed);
 
-	Must(!state.doneSending);
-	parseMore();
+    Must(!state.doneSending);
+    parseMore();
 
-	ICAPXaction_Exit(noteSinkNeed);
+    ICAPXaction_Exit(noteSinkNeed);
 }
 
 // HTTP side aborted
-void ICAPXaction::noteSinkAbort(MsgPipe *p) {
-	ICAPXaction_Enter(noteSinkAbort);
+void ICAPXaction::noteSinkAbort(MsgPipe *p)
+{
+    ICAPXaction_Enter(noteSinkAbort);
 
-	mustStop(notifyService);
+    mustStop(notifyService);
 
-	ICAPXaction_Exit(noteSinkAbort);
+    ICAPXaction_Exit(noteSinkAbort);
 }
 
-void ICAPXaction::pickService() {
-	// TODO: select the service based on config, ACLs, etc.
-	static ICAPServiceRep TheService;
-	service = &TheService;
+void ICAPXaction::pickService()
+{
+    // TODO: select the service based on config, ACLs, etc.
+    static ICAPServiceRep TheService;
+    service = &TheService;
 }
 
-void ICAPXaction::mustStop(Notify who) {
-	Must(state.inCall); // otherwise nobody will call doStop()
-	Must(notify == notifyUnknown);
-	notify = who;
-	debugs(93, 5, "ICAPXaction will stop and notify " << notify);
+void ICAPXaction::mustStop(Notify who)
+{
+    Must(state.inCall); // otherwise nobody will call doStop()
+    Must(notify == notifyUnknown);
+    notify = who;
+    debugs(93, 5, "ICAPXaction will stop and notify " << notify);
 }
 
 // internal cleanup
-void ICAPXaction::doStop() {
-	debugs(93, 5, "ICAPXaction::doStop");
+void ICAPXaction::doStop()
+{
+    debugs(93, 5, "ICAPXaction::doStop");
+
+    memBufClean(&readBuf);
+    memBufClean(&requestBuf);
+
+    closeConnection(); // TODO: pconn support: close unless notifyService ...
+
+    if (virgin) {
+        if (notify == notifyHttp || notify == notifyAll)
+            virgin->sendSinkAbort();
+        else
+            virgin->sink = NULL;
+
+        // this is the place to decrement refcount ptr
+        virgin = NULL;
+    }
+
+    if (adapted) {
+        if (notify == notifyHttp || notify == notifyAll)
+            adapted->sendSourceAbort();
+        else
+            adapted->source = NULL;
+
+        // this is the place to decrement refcount ptr
+        adapted = NULL;
+    }
+
+    if (self != NULL) { // even if notify is notifyNone
+        Pointer s = self;
+        self = NULL;
+        ICAPNoteXactionDone(s);
+        /* this object may be destroyed when 's' is cleared */
+    }
+}
+
+void ICAPXaction::makeRequestHeaders()
+{
+    HttpRequest *&httpReq = virgin->data->cause;
+    HttpReply *&httpResp = virgin->data->header;
+    Must(httpReq);  // require request headers for now
+    Must(httpResp);
+
+    MemBuf httpBuf;
+    memBufDefInit(&httpBuf);
+
+    /* build HTTP request header */
+
+    // HTTP Request-line
+    memBufPrintf(&httpBuf, "%s %s HTTP/%d.%d\r\n",
+                 RequestMethodStr[httpReq->method],
+                 httpReq->urlpath.size() ? httpReq->urlpath.buf() : "/",
+                 httpReq->http_ver.major, httpReq->http_ver.minor);
+
+    // HTTP Request header fields
+    Packer p;
+    packerToMemInit(&p, &httpBuf);
+    httpHeaderPackInto(&httpReq->header, &p);
+    packerClean(&p);
+    httpBuf.append(crlf, 2); // CRLF terminator
+    const size_t httpRespOffset = httpBuf.contentSize();
+
+    // build HTTP response header
+    packerToMemInit(&p, &httpBuf);
+    httpStatusLinePackInto(&httpResp->sline, &p);
+    httpHeaderPackInto(&httpResp->header, &p);
+    packerClean(&p);
+    httpBuf.append(crlf, 2); // CRLF terminator
+    const size_t httpBodyOffset = httpBuf.contentSize();
+
+    /* ICAP request header */
+    MemBuf *buf = &requestBuf;
+    memBufPrintf(buf, "RESPMOD %s ICAP/1.0\r\n", service->uri);
+    memBufPrintf(buf, "Host: %s:%d\r\n", service->host, service->port);
+    memBufPrintf(buf, "Encapsulated: req-hdr=%d,res-hdr=%d,res-body=%d\r\n",
+                 0, httpRespOffset, httpBodyOffset);
+    buf->append(crlf, 2); // CRLF terminator
+
+    /* ICAP request body */
+    buf->append(httpBuf.content(), httpBuf.contentSize());
+}
+
+bool ICAPXaction::callStart(const char *method)
+{
+    debugs(93, 5, "ICAPXaction::" << method << " called " << status());
+
+    if (state.inCall) {
+        // this may happen when we have bugs or when arguably buggy
+        // comm interface calls us while we are closing the connection
+        debugs(93, 5, "ICAPXaction::" << method << " cancels reentry.");
+        return false;
+    }
+
+    state.inCall = true;
+    return true;
+}
+
+void ICAPXaction::callException(const char *method, const TextException &e, Notify defaultWho)
+{
+    debugs(93, 4, "ICAPXaction::" << method << " caught an exception: " <<
+           e.message << ' ' << status());
+
+    if (!done())
+        mustStop(defaultWho);
+}
+
+void ICAPXaction::callEnd(const char *method)
+{
+    if (done()) {
+        debugs(93, 5, "ICAPXaction::" << method << " ends xaction " <<
+               status());
+        doStop();
+        return;
+    }
 
-	memBufClean(&readBuf);
-	memBufClean(&requestBuf);
+    debugs(93, 6, "ICAPXaction::" << method << " ended " << status());
+    state.inCall = false;
+}
+
+// returns a temporary string depicting transaction status, for debugging
+const char *ICAPXaction::status() const
+{
+    static MemBuf status;
+    memBufReset(&status);
+
+    status.append("[", 1);
+
+    if (notify != notifyUnknown)
+        memBufPrintf(&status, "N(%d)", notify);
 
-	closeConnection(); // TODO: pconn support: close unless notifyService ...
+    if (state.doneReceiving)
+        status.append("R", 1);
 
-	if (virgin) {
-		if (notify == notifyHttp || notify == notifyAll)
-			virgin->sendSinkAbort();
-		else
-			virgin->sink = NULL;
-		// this is the place to decrement refcount ptr
-		virgin = NULL;
-	}
-	if (adapted) {
-		if (notify == notifyHttp || notify == notifyAll)
-			adapted->sendSourceAbort();
-		else
-			adapted->source = NULL;
-		// this is the place to decrement refcount ptr
-		adapted = NULL;
-	}
-
-	if (self != NULL) { // even if notify is notifyNone
-		Pointer s = self;
-		self = NULL;
-		ICAPNoteXactionDone(s);
-		/* this object may be destroyed when 's' is cleared */
-	}
-}
-
-void ICAPXaction::makeRequestHeaders() {
-	HttpRequest *&httpReq = virgin->data->cause;
-	HttpReply *&httpResp = virgin->data->header;
-	Must(httpReq);  // require request headers for now
-	Must(httpResp);
-
-	MemBuf httpBuf;
-	memBufDefInit(&httpBuf);
-
-	/* build HTTP request header */
-
-	// HTTP Request-line
-	memBufPrintf(&httpBuf, "%s %s HTTP/%d.%d\r\n",
-		RequestMethodStr[httpReq->method],
-		httpReq->urlpath.size() ? httpReq->urlpath.buf() : "/",
-		httpReq->http_ver.major, httpReq->http_ver.minor);
-
-	// HTTP Request header fields
-	Packer p;
-	packerToMemInit(&p, &httpBuf);
-	httpHeaderPackInto(&httpReq->header, &p);
-	packerClean(&p);
-	httpBuf.append(crlf, 2); // CRLF terminator
-	const size_t httpRespOffset = httpBuf.contentSize();
-
-	// build HTTP response header
-	packerToMemInit(&p, &httpBuf);
-	httpStatusLinePackInto(&httpResp->sline, &p);
-	httpHeaderPackInto(&httpResp->header, &p);
-	packerClean(&p);
-	httpBuf.append(crlf, 2); // CRLF terminator
-	const size_t httpBodyOffset = httpBuf.contentSize();
-
-	/* ICAP request header */
-	MemBuf *buf = &requestBuf;
-	memBufPrintf(buf, "RESPMOD %s ICAP/1.0\r\n", service->uri);
-	memBufPrintf(buf, "Host: %s:%d\r\n", service->host, service->port);
-	memBufPrintf(buf, "Encapsulated: req-hdr=%d,res-hdr=%d,res-body=%d\r\n",
-		0, httpRespOffset, httpBodyOffset);
-	buf->append(crlf, 2); // CRLF terminator
-
-	/* ICAP request body */
-	buf->append(httpBuf.content(), httpBuf.contentSize());
-}
-
-bool ICAPXaction::callStart(const char *method) {
-	debugs(93, 5, "ICAPXaction::" << method << " called " << status());
-	if (state.inCall) {
-		// this may happen when we have bugs or when arguably buggy
-		// comm interface calls us while we are closing the connection
-		debugs(93, 5, "ICAPXaction::" << method << " cancels reentry.");
-		return false;
-	}
-
-	state.inCall = true;
-	return true;
-}
-
-void ICAPXaction::callException(const char *method, const TextException &e, Notify defaultWho) {
-	debugs(93, 4, "ICAPXaction::" << method << " caught an exception: " <<
-		e.message << ' ' << status());
-	if (!done())
-		mustStop(defaultWho);
-}
-
-void ICAPXaction::callEnd(const char *method) {
-	if (done()) {
-		debugs(93, 5, "ICAPXaction::" << method << " ends xaction " <<
-			status());
-		doStop();
-		return;
-	}
+    if (state.doneSending)
+        status.append("S", 1);
 
-	debugs(93, 6, "ICAPXaction::" << method << " ended " << status());
-	state.inCall = false;
+    if (state.doneReading)
+        status.append("r", 1);
+
+    if (state.doneWriting)
+        status.append("w", 1);
+
+    status.append("]", 1);
+
+    status.terminate();
+
+    return status.content();
 }
 
-// returns a temporary string depicting transaction status, for debugging
-const char *ICAPXaction::status() const {
-	static MemBuf status;
-	memBufReset(&status);
-
-	status.append("[", 1);
-	if (notify != notifyUnknown)
-		memBufPrintf(&status, "N(%d)", notify);
-	if (state.doneReceiving)
-		status.append("R", 1);
-	if (state.doneSending)
-		status.append("S", 1);
-	if (state.doneReading)
-		status.append("r", 1);
-	if (state.doneWriting)
-		status.append("w", 1);
-	status.append("]", 1);
-
-	status.terminate();
-	return status.content();
-}
-
-bool ICAPXaction::gotEncapsulated(const char *section) const {
-	return httpHeaderGetByNameListMember(&icapReply->header, "Encapsulated",
-		section, ',').size() > 0;
+bool ICAPXaction::gotEncapsulated(const char *section) const
+{
+    return httpHeaderGetByNameListMember(&icapReply->header, "Encapsulated",
+                                         section, ',').size() > 0;
 }
